      PROGRAM TECTEST
C ---------------------------------------------
C
C     test Tektronix output via FORTRAN
C
C     Martin Hepperle, 11/2018
C
C     f80 =tectest
C     l80 tectest/N,tectest,teclib/S/E
C
C ---------------------------------------------
      REAL PI,X,Y

      LOGICAL*1 TEXT(20)
C     Microsoft FORTRAN
C     Units 1,3,5 are all preassigned to TTY:
C     Unit 2 is preassigned to LST:
C     Unit 4 is preassigned to RDR: resp. PUN:
      INTEGER IDEV,TTY,LST,RDR,PUN
      DATA TTY,LST,RDR,PUN /1,2,4,4/

1000  FORMAT(1H ,'Enter output device: 1,3,5=CON:, 2=LST:, 4=PUN:  > ')
1010  FORMAT(I1)

10    WRITE(TTY,1000)
      READ(TTY,1010) IDEV
      IF ( IDEV .LT. 1 .OR. IDEV .GT. 4 ) GOTO 10

C
C     Test Tektronix emulation in Teraterm
C


C     select output device
      CALL TINIT(IDEV)

C     clear screen
      CALL TCLEAR

C     setup first viewport position
      CALL TVIEW(0.05,0.5, 0.0,0.5)
C     demo plot into first window
      CALL PLOTIT

C     setup second viewport position
      CALL TVIEW(0.5,1.0, 0.5,1.0)
C     demo plot into second window
      CALL PLOTIT

      CALL TXRAST(0.0,6.2832,3.14159,-1.0,1.0)
      CALL TYRAST(-1.0,1.0,0.5,0.0,6.2832)


C     setup third viewport position
      CALL TVIEW(0.5,0.9,  0.1,0.5)
C     setup window
      CALL TWIND(-3.0,8.0,-1.0,5.0)

C     draw a frame around this viewport
      CALL TRECT(-3.0,-1.0, 8.0,5.0)

      CALL TXAXIS(-3.0,8.0,0.0,0.5,20.0)
      CALL TYAXIS(-1.0,5.0,0.0,0.5,20.0)

      X = 5.0
      Y = 0.0
      CALL TNUM ( X, Y, 90.0, 0.0, 1.2345, 0, 10 )
      X = 5.0
      Y = 0.5
      CALL TNUM ( X, Y, 90.0, 0.0, 1.2345, 1, 10 )
      X = 5.0
      Y = 1.0
      CALL TNUM ( X, Y, 90.0, 0.0, 1.2345, 2, 10 )
      X = 5.0
      Y = 1.5
      CALL TNUM ( X, Y, 90.0, 0.0, 1.2345, 3, 10 )
      X = 5.0
      Y = 2.0
      CALL TNUM ( X, Y, 90.0, 0.0, 1.2345, 4, 10 )
      X = 5.0
      Y = 2.5
      CALL TNUM ( X, Y, 90.0, 0.0, 1.2345, 4, 00 )
      X = 5.0
      Y = 2.5
      CALL TNUM ( X, Y, 90.0, 0.0, 1.2345, 4, 20 )

      X = 1.0
      Y = 3.0
      CALL TTEXT ( X, Y, 'Some Text', 9, 100.0, 0.0 )
      X = 1.0
      Y = 3.5
      CALL TTEXT ( X, Y, 'More Text', 9, 100.0, 0.0 )

      TEXT(1) = 'H'
      TEXT(2) = 'e'
      TEXT(3) = 'l'
      TEXT(4) = 'l'
      TEXT(5) = 'o'
      TEXT(6) = ' '
      TEXT(7) = 'W'
      TEXT(8) = 'o'
      TEXT(9) = 'r'
      TEXT(10) = 'l'
      TEXT(11) = 'd'
      X = 1.0
      Y = 4.0
      CALL TTEXT ( X, Y, TEXT, 11, 100.0, 0.0 )

      X1 = -6.0
      Y1 = 1.0
      X2 = 3.0
      Y2 = 7.0
      CALL TMOVEC(X1,Y1)
      CALL TDRAWC(X2,Y2)

      X1 = 0.0
      Y1 = -3.0
      X2 = 3.0
      Y2 = 3.0
      CALL TMOVEC(X1,Y1)
      CALL TDRAWC(X2,Y2)

      X1 = 9.0
      Y1 = 0.0
      X2 = 6.0
      Y2 = 3.0
      CALL TMOVEC(X1,Y1)
      CALL TDRAWC(X2,Y2)

      X1 = 5.0
      Y1 = -4.0
      X2 = 5.0
      Y2 = 2.5
      CALL TMOVEC(X1,Y1)
      CALL TDRAWC(X2,Y2)

      X1 = -7.0
      Y1 = 2.0
      X2 = 6.0
      Y2 = 2.0
      CALL TMOVEC(X1,Y1)
      CALL TDRAWC(X2,Y2)

      X1 = 1.0
      Y1 = 2.0
      R  = 1.0
      CALL TARC(X1,Y1,R,0.0,90.0,10.0)
      R  = 1.1
      CALL TARC(X1,Y1,R,0.0,180.0,10.0)
      R  = 1.2
      CALL TARC(X1,Y1,R,0.0,270.0,10.0)

      R  = 1.5
      CALL TARC(X1,Y1,R,0.0,360.0,45.0)

C     back to VT window
      CALL TCLOSE

      END

C-----------------------------------------------------------------

      SUBROUTINE PLOTIT

C     setup window scaling
      CALL TWIND(-0.1,6.9, -1.1,1.1)

      PI = 4.0*ATAN(1.0)

C     plot x-axis
      CALL TXAXIS(0.0,2.0*PI,0.0,PI/10.0,20.0)
      CALL TXALAB(0.0,2.0*PI,-0.1,PI/2.0,40.0,0.0,2)

C     plot y-axis
      CALL TYAXIS(-1.0,1.0,0.0,0.1,20.0)
      CALL TYALAB(-1.0,1.0,-0.2,0.5,40.0,0.0,2)

C     draw sine curve
      X = 0.0
      Y = SIN(X)
      CALL TMOVE(X,Y)
200   Y = SIN(X)
      CALL TDRAW(X,Y)
      X = X + PI/20.0
      IF ( X .LE. 2.001*PI ) GOTO 200

C     draw cosine curve
      X = 0.0
      Y = COS(X)
      CALL TMOVE(X,Y)
300   Y = COS(X)
      CALL TDRAW(X,Y)
      X = X + PI/20.0
      IF ( X .LE. 2.001*PI ) GOTO 300

      RETURN
      END
C ---------------------------------------------
